#include "DataPositionType.h"

void resetDataPositionList(SortedDataPositionList* position_list)
{
	if (position_list) {
		for (size_t i = 0; i<position_list->size(); i++) {
			DataPositionType* postype = position_list->at(i);
			if (postype) {
				postype->setPosition(0);
			}
		}
	}
}

void clearDataPositionList(SortedDataPositionList* position_list)
{
	if (position_list) {
		for (size_t i = 0; i<position_list->size(); i++) {
			DataPositionType* postype = position_list->at(i);
			if (postype) {
				delete postype;
			}
		}
		position_list->clear();
	}
}

void deleteDataPositionList(SortedDataPositionList* position_list)
{
	clearDataPositionList(position_list);
	if(position_list){
		delete position_list;
	}
}

SortedDataPositionList* copyDataPositionList(SortedDataPositionList* position_list)
{
	SortedDataPositionList* result_position_list = 0;
	if(position_list){
		result_position_list = new SortedDataPositionList();
		result_position_list->resize(position_list->size());
		for(size_t i=0;i<position_list->size();i++){
			(*result_position_list)[i] = new DataPositionType(*position_list->at(i));
		}
	}
	return result_position_list;
}
