
/*
 *  Material Modeling Platform Package
 *  Copyright(c) 2002, The Japan Research Institute, Ltd.
 *  All rights reserved.
 *  
 *  $Id: FileStreamManager.cpp,v 1.11 2007/06/04 11:16:19 nishimoto Exp $
 */

#ifdef WIN32
#pragma warning (disable:4786)
#endif

#include <stdio.h>
#include <string.h>
#if defined(WIN32)
# include <sys/types.h>
# include <sys/stat.h>
#if defined(__MINGW32__)
# include <unistd.h>
#endif
typedef struct stat _STRUCT_STAT;
#else
# include <sys/stat.h>
# include <unistd.h>
typedef struct stat _STRUCT_STAT;
#endif

#include "FileStreamManager.h"
#include "cache_util_function.h"
#include "cache_util_character.h"
#include "StructureCacheCommon.h"
using namespace CacheUtilCore;
#include <algorithm>
using namespace std;

// DataLocation.
//DataLocation::DataLocation()
//{
//	_part = 0;
//	_location = 0;
//	_file = 0x0;
//}
//DataLocation::DataLocation(short part, short loc, const char* file)
//{
//	_file = 0x0;
//	setLoc( part,loc,file );
//}
//DataLocation::~DataLocation()
//{
//	if(_file) free(_file);
//}
//void
//DataLocation::setLoc( short part, short loc, const char* file )
//{
//	_part = part;
//	_location = loc;
//	if(_file) free(_file);
//	_file = strdup(file);
//}
//void
//DataLocation::getLoc( short* part, short* loc, char** file )
//{
//	*part = _part;
//	*loc = _location;
//	*file = _file;
//}
// DataLocationInfo.
//DataLocationInfo::DataLocationInfo()
//{
//}
//DataLocationInfo::~DataLocationInfo()
//{
//	clearLocInfo();
//}
//int
//DataLocationInfo::insertLocInfo(
//	const char* name,
//	short part,
//	short loc,
//	const char* file
//)
//{
//	DataLocation* dlp = 0x0;
//	typedef multimap<string,DataLocation*>::iterator MI;
//	pair<MI,MI> gg = _dtloc.equal_range( name );
//	for( MI pp = gg.first ; pp != gg.second ; pp++ ){
//		if(part == pp->second->_part){
//			dlp = pp->second;
//			break;
//		}
//	}
//	if(dlp){
//		dlp->setLoc(part,loc,file);
//	}
//	else{
//		dlp = new DataLocation(part,loc,file);
//	}
//	_dtloc.insert(make_pair(name,dlp));
//	return _dtloc.size();
//}
//int
//DataLocationInfo::getLocInfo(
//	const char* name,
//	short part,
//	short* loc,
//	char** file
//)
//{
//	DataLocation* dlp = 0x0;
//	typedef multimap<string,DataLocation*>::iterator MI;
//	pair<MI,MI> gg = _dtloc.equal_range( name );
//	for( MI pp = gg.first ; pp != gg.second ; pp++ ){
//		if(part == pp->second->_part){
//			dlp = pp->second;
//			break;
//		}
//	}
//	if(dlp){
//		dlp->getLoc( &part, loc, file );
//		return 1;
//	}
//	return 0;
//}
//void
//DataLocationInfo::clearLocInfo()
//{
//	multimap<string,DataLocation*>::iterator pp;
//	pp = _dtloc.begin();
//	while( pp !=  _dtloc.end() ){
//		char* nm = (char*)pp->first.c_str();
//		DataLocation* dlt = pp->second;
//		delete dlt;
//		pp++;
//	}
//	_dtloc.clear();
//}
/////////////////////////////////////////////////////////////////////
static bool file_exist( const char *file )
{
	return (fcache_file_exist( file ) > 0);

}
/////////////////////////////////////////////////////////////////////
////////// TemporaryCacheRecord
/////////////////////////////////////////////////////////////////////
/**
void TemporaryCacheRecord::clear()
{
	if(record_label) delete[] record_label;
	if(filepath) delete[] filepath;
	record_no = 0;
	record_label = 0x0;
	filepath = 0x0;
}
void
TemporaryCacheRecord::setRecordNo( const UINT number )
{
	record_no = number;
}
void
TemporaryCacheRecord::setFile( const char* path )
{
	if(filepath) delete[] filepath;
	filepath = 0x0;
	if(path) filepath = newCopyStr(path);
}
void
TemporaryCacheRecord::setLabel( const char* label )
{
	if(record_label) delete[] record_label;
	record_label = 0x0;
	if(label) record_label = newCopyStr(label);
}
**/
/////////////////////////////////////////////////////////////////////
////////// TemporaryRecordData
/////////////////////////////////////////////////////////////////////
/**
TemporaryRecordData::TemporaryRecordData()
{
}

TemporaryRecordData::~TemporaryRecordData()
{
	clear();
}

void
TemporaryRecordData::clear()
{
	if(_tmprec.size() > 0){
		for(data_iterator pp = _tmprec.begin();pp != _tmprec.end();pp++){
			delete pp->second;
		}
		_tmprec.clear();
	}
}

bool
TemporaryRecordData::insert(
		UINT record_no, 
		const char* record_label, 
		const char* filepath
)
{
	TemporaryCacheRecord *tmpRec = 0x0;
	data_iterator pp = _tmprec.find( record_no );
	if( pp != _tmprec.end() ){
		tmpRec = pp->second;
	}
	if(tmpRec){
		if(record_label) tmpRec->setLabel(record_label);
		if(filepath) tmpRec->setFile(filepath);
		tmpRec->avail();
	}
	else{
		tmpRec = new TemporaryCacheRecord();
		///////////////////////////////
		tmpRec->setRecordNo(record_no);
		if(record_label) tmpRec->setLabel(record_label);
		if(filepath) tmpRec->setFile(filepath);
		///////////////////////////////
		_tmprec.insert(make_pair(record_no,tmpRec));
	}
	return true;
}

// By a record number.
bool
TemporaryRecordData::get( 
		UINT record_no, 
		TemporaryCacheRecord** tmprecp,
		bool forceGet,
		bool eraseOption
)
{
	TemporaryCacheRecord *tmpRec = 0;
	data_iterator pp = _tmprec.find( record_no );
	if( pp != _tmprec.end() ){
		tmpRec = pp->second;
		if(!forceGet){
			if(!tmpRec->available()){
				tmpRec = 0;
			}
		}
	}
	if(tmpRec){
		if(eraseOption) _tmprec.erase(pp);
		*tmprecp = tmpRec;
		return true;
	}
	return false;
}

// By a record label.
bool
TemporaryRecordData::get( 
		const char* record_label,
		TemporaryCacheRecord** tmprecp,
		bool forceGet,
		bool eraseOption
)
{
	TemporaryCacheRecord *tmpRec = 0x0;
	data_iterator pp = _tmprec.begin();
	while( pp != _tmprec.end() ){
		tmpRec = pp->second;
		if(strcmp(tmpRec->getLabel(),record_label) == 0){
			if(forceGet) break;
			else{
				if(tmpRec->available()){
					break;
				}
			}
		}
		tmpRec = 0;
		pp++;
	}
	if(tmpRec){
		if(eraseOption) _tmprec.erase(pp);
		*tmprecp = tmpRec;
		return true;
	}
	return false;
}

UINT
TemporaryRecordData::getAll(
	vector<TemporaryCacheRecord*>& tmprec_array,
	bool forceGet
)
{
	tmprec_array.clear();
	TemporaryCacheRecord *tmpRec = 0x0;
	data_iterator pp = _tmprec.begin();
	while( pp != _tmprec.end() ){
		tmpRec = pp->second;
		if(forceGet) tmprec_array.push_back(tmpRec);
		else if(tmpRec->available()){
			tmprec_array.push_back(tmpRec);
		}
		pp++;
	}
	return tmprec_array.size();
}

UINT TemporaryRecordData::getSize()
{
	UINT counter = 0;
	TemporaryCacheRecord *tmpRec = 0x0;
	data_iterator pp = _tmprec.begin();
	while( pp != _tmprec.end()){
		tmpRec = pp->second;
		if(tmpRec->available()){
			counter++;
		}
		pp++;
	}
	return counter;
}

// Compare function.
static
bool lessRecordNumber(const TemporaryCacheRecord* s1,const TemporaryCacheRecord* s2)
{
	return (s1->getRecordNo() < s2->getRecordNo());
}

void
TemporaryRecordData::sortByRecord()
{
	// already sorted in using map.
	//if(_tmprec.size() > 1){
	//	sort(_tmprec.begin(),_tmprec.end(),lessRecordNumber);
	//}
}
**/
/////////////////////////////////////////////////////////////////////
////////// CacheVirtualRecord
/////////////////////////////////////////////////////////////////////
/**
CacheVirtualRecord_::CacheVirtualRecord_()
{
	_set_temporary_directory = false;
}
CacheVirtualRecord_::~CacheVirtualRecord_()
{
	this->clearVirtualRecord();
}
void CacheVirtualRecord_::clearVirtualRecord()
{
	this->eraseFile();
	_edit_record.clear();
	_apnd_record.clear();
	_delt_record.clear();
	clearDirectory();
}
bool
CacheVirtualRecord_::insertVRec(
		E_CACHE_VIRTUAL_RECORD_ACCESS raccss,
		UINT record_no, 
		const char* record_label, 
		const char* filepath
)
{
	switch(raccss){
	case eVIRTUAL_ACCESS_EDIT:
		_edit_record.insert(record_no,record_label,filepath);
		break;
	case eVIRTUAL_ACCESS_APPEND:
		_apnd_record.insert(record_no,record_label,filepath);
		break;
	case eVIRTUAL_ACCESS_DELETE:
		// Only one exists at the maximum.
		if(_delt_record.getSize() > 0){
			TemporaryCacheRecord* tempRec = _delt_record.getCacheRecord(0);
			if(!tempRec) return false;
			if(record_no < tempRec->getRecordNo()){
				tempRec->setRecordNo(record_no);
			}
		}
		else{
			_delt_record.insert(record_no,0,0);
		}
		_edit_record.annul(record_no);
		_apnd_record.annul(record_no);
		break;
	default:
		return false;
	}
	return true;
}
bool
CacheVirtualRecord_::getVRec(
		E_CACHE_VIRTUAL_RECORD_ACCESS raccss,
		UINT record_no, 
		TemporaryCacheRecord** tmprec,
		bool forceGet,
		bool eraseOption
)
{
	bool rb = false;
	switch(raccss){
	case eVIRTUAL_ACCESS_EDIT:
		rb = _edit_record.get(record_no,tmprec,forceGet,eraseOption);
		break;
	case eVIRTUAL_ACCESS_APPEND:
		rb = _apnd_record.get(record_no,tmprec,forceGet,eraseOption);
		break;
	case eVIRTUAL_ACCESS_DELETE:
		rb = _delt_record.get(record_no,tmprec,forceGet,eraseOption);
		break;
	default: // BOTH(EDIT/APPEND).
		//if(deleteRecord(record_no)) return false;
		rb = _apnd_record.get(record_no,tmprec,forceGet,eraseOption);
		if(!rb){
			rb = _edit_record.get(record_no,tmprec,forceGet,eraseOption);
		}
	}
	return rb;
}
bool
CacheVirtualRecord_::getVRec(
		E_CACHE_VIRTUAL_RECORD_ACCESS raccss,
		const char* record_label, 
		TemporaryCacheRecord** tmprec, 
		bool forceGet,
		bool eraseOption
)
{
	bool rb = false;
	switch(raccss){
	case eVIRTUAL_ACCESS_EDIT:
		rb = _edit_record.get(record_label,tmprec,forceGet,eraseOption);
		break;
	case eVIRTUAL_ACCESS_APPEND:
		rb = _apnd_record.get(record_label,tmprec,forceGet,eraseOption);
		break;
	default: // BOTH.
		rb = _apnd_record.get(record_label,tmprec,forceGet,eraseOption);
		if(!rb){
			rb = _edit_record.get(record_label,tmprec,forceGet,eraseOption);
		}
	}
	//if(rb){ // delete record.
	//	if((*tmprec)->available()) return true;
	//	if(deleteRecord((*tmprec)->getRecordNo())) return false;
	//}
	return rb;
}
UINT
CacheVirtualRecord_::getAllVRec(
		E_CACHE_VIRTUAL_RECORD_ACCESS raccss,
		vector<TemporaryCacheRecord*>& tmprec_array
)
{
	UINT num = 0;
	switch(raccss){
	case eVIRTUAL_ACCESS_EDIT:
		num = _edit_record.getAll(tmprec_array);
		break;
	case eVIRTUAL_ACCESS_APPEND:
		num = _apnd_record.getAll(tmprec_array);
		break;
	case eVIRTUAL_ACCESS_DELETE:
		num = _delt_record.getAll(tmprec_array);
		break;
	default: // BOTH.
		return 0;
	}
	return num;
}
UINT
CacheVirtualRecord_::getAllNum(
	E_CACHE_VIRTUAL_RECORD_ACCESS raccss
)
{
	switch(raccss){
	case eVIRTUAL_ACCESS_EDIT:
		return _edit_record.getSize();
	case eVIRTUAL_ACCESS_APPEND:
		return _apnd_record.getSize();
	case eVIRTUAL_ACCESS_DELETE:
		return _delt_record.getSize();
		break;
	default: // BOTH.
		return 0;
	}
	return 0;
}
UINT CacheVirtualRecord_::getUnconditionalAllSize()
{
	return (
		  _edit_record.getUnconditionalSize()
		+ _apnd_record.getUnconditionalSize()
		+ _delt_record.getUnconditionalSize()
		);
}
void 
CacheVirtualRecord_::sortingRecord()
{
	this->_apnd_record.sortByRecord();
	this->_edit_record.sortByRecord();
}
bool
CacheVirtualRecord_::eraseFile()
{
	UINT i,num;
	vector<TemporaryCacheRecord*> tmprec_array;
	num = _edit_record.getAll(tmprec_array,true);
	for(i=0;i<num;i++){
		if(file_exist(tmprec_array[i]->getFile())){
			unlink(tmprec_array[i]->getFile());
		}
	}
	num = _apnd_record.getAll(tmprec_array,true);
	for(i=0;i<num;i++){
		if(file_exist(tmprec_array[i]->getFile())){
			unlink(tmprec_array[i]->getFile());
		}
	}
	//// Directory ////
	if(directory() && getDirectory().size() > 1){
		const char* path = getDirectory().c_str();
		if(fcache_dir_delete( path ) != 0){
			clearDirectory();
			return false;
		}
		clearDirectory();
	}
	return true;
}
**/

/////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////
////////// FileStreamManager
/////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////

FileStreamManager::FileStreamManager( bool temporary_file )
{
	initializeOperation();
	_fss = 0x0;
	//_data_loc_info = new DataLocationInfo();
	_save_divided_record = false;
	_convert_divided_mode = 0;
	_temporary_file = temporary_file;
	_output_only_file = NULL;
	_last_opened_is_virtual = false;
	//_last_opend_file = NULL;
	//_is_user_directory = false;
	//_is_user_record_name = false;
	//_is_user_object_file = false;
	_initial_rec = 0;
	_initial_rec_last = false;
	_object_priority = true;
	_record_directory = 0;
	_object_directory = 0;
	_record_file_name = 0;
	_draw_object_file = 0;
	_rec_operation = new CacheRecordOperation( 0 );
}

FileStreamManager::FileStreamManager( const char* path )
{
	initializeOperation();
	if(path) _file.path = path;
	_fss = 0x0;
	//_data_loc_info = new DataLocationInfo();
	_save_divided_record = false;
	_convert_divided_mode = 0;
	_temporary_file = false;
	_output_only_file = NULL;
	_last_opened_is_virtual = false;
	//_last_opend_file = NULL;
	//_is_user_directory = false;
	//_is_user_record_name = false;
	//_is_user_object_file = false;
	_initial_rec = 0;
	_initial_rec_last = false;
	_object_priority = true;
	_record_directory = 0;
	_object_directory = 0;
	_record_file_name = 0;
	_draw_object_file = 0;
	_rec_operation = new CacheRecordOperation( 0 );
}

FileStreamManager::~FileStreamManager()
{
	// temporary file.
	deleteTemporary();
	// memory.
	if(_fss){
		_fss->close();
		delete _fss;
	}
	//if(_data_loc_info) delete _data_loc_info;
	if(_output_only_file) delete[] _output_only_file;
	//if(_last_opend_file) delete[] _last_opend_file;
	if(_record_directory) delete[] _record_directory;
	if(_object_directory) delete[] _object_directory;
	if(_record_file_name) delete[] _record_file_name;
	if(_draw_object_file) delete[] _draw_object_file;
	if(_rec_operation) delete _rec_operation;
#ifdef FSM_DEBUG
	fprintf(stderr,"!!! Destruct FileStreamManager !!!\n");
#endif
}

void
FileStreamManager::initializeOperation()
{
	_file.faccess = 0;
	_file.file_time = 0;
	_file.rec_size = 0;
	_file.read_lineno = 0;
	_file.last_position = 0;
}
void
FileStreamManager::initOperation()
{
	//_file.file_time = 0;
	_file.rec_size = 0;
	_file.read_lineno = 0;
	_file.last_position = 0;
}
void
FileStreamManager::clearOperation(bool reload)
{
	// No need for clearing a file path.
	// if(_file.path) free(_file.path);
	// if(_file.name) free(_file.name);
	///////////////////////////////////
	_file.includes.clear();
	// Labels & Positions of records.
	_file.rec_labelpos.clearRec(reload);
}

void FileStreamManager::createRecordOperation()
{
	if(_rec_operation){
		delete _rec_operation;
	}
	_rec_operation = new CacheRecordOperation( getRecSize() );
}

// Private methods below.
void FileStreamManager::set_last_opened_file( const char* path, bool is_virtual )
{
	if(!path) return;
	_last_opend_file.assign(path);
	_last_opened_is_virtual = is_virtual;

	//if(_last_opend_file) delete[] _last_opend_file;
	//_last_opend_file = NULL;
	//_last_opend_file = new char[ strlen( path ) + 1 ];
	//strcpy(_last_opend_file, path);
}
time_t
FileStreamManager::get_time_status( const char* path )
{
	int rc = 0;
	time_t tmt = 0;
	_STRUCT_STAT buf;
	if(path){
		rc = stat(path,&buf);
		if(rc == 0){
			tmt = buf.st_mtime;
		}
	}
	return tmt;
}

int
FileStreamManager::setFile( const char* path, int timeopt )
{
	char* file = 0x0;
	if(path){
		file = (char*)path;
		_file.path = file;
		string relpath = file;
		// convert into an absolute path.
		futl_string_abspath( _file.path, relpath );
	}
	else file = (char*)_file.path.c_str();
	if(!file) return 0;
	if( !exfile( file ) ) return 0;
	// Taking of the last modification time.
	if(timeopt == 0) _file.file_time = get_time_status(path);
	// WRITE-ALLOWABLILITY.
	switch(fcache_file_access(file)){
	case 2: // READ-ONLY.
		_file.faccess = 0;
		break;
	case 6: // READ & WRITE.
		_file.faccess = 1;
		break;
	default:
		_file.faccess = -1;
		break;
	}
	// Temporary file.
	if(_temporary_file){
		if(_temporary_file_name.size() <= 0){
			// Only setted first.
			_temporary_file_name = file;
		}
	}
	return 1;
}

bool
FileStreamManager::exfile( const char* path )
{
	return (fcache_file_exist(path) > 0);
}

char*
FileStreamManager::getFile()
{
	return (char*)_file.path.c_str();
}
/*
bool FileStreamManager::getReadFile(unsigned int record, string& read_file)
{
	CacheRecordOperation* recop = getRecordOperation();
	if(recop->isEditedRecord(record) ){
		const char* filepath = recop->getEditedRecordFilePath(record);
		if(filepath){
			read_file.assign(filepath);
			return true;
		}
	}
	else if(isDividedRecord()){
		bool binary;
		if(getRecInfo(record, 0, 0, 0, &read_file, &binary)){
			return true;
		}
	}
	const char* filepath = getFile();
	if(filepath){
		read_file.assign(filepath);
		return true;
	}
	return false;
}
*/
bool FileStreamManager::getReadFile(unsigned int record, string& read_file, bool get_virtual)
{
	CacheRecordOperation* recop = getRecordOperation();
	if (get_virtual && recop->isEditedRecord(record)) {
		const char* filepath = recop->getEditedRecordFilePath(record);
		if (filepath) {
			read_file.assign(filepath);
			return true;
		}
		// Not yet written to a file.
		read_file.clear();
		return true;
	}
	else if (isDividedRecord()) {
		bool binary;
		if (getRecInfo(record, 0, 0, 0, &read_file, &binary)) {
			return true;
		}
	}
	const char* filepath = getFile();
	if (filepath) {
		read_file.assign(filepath);
		return true;
	}
	return false;
}

void FileStreamManager::setOutputFile( const char* file )
{
	if(!file) return;
	if(_output_only_file) delete[] _output_only_file;
	_output_only_file = NULL;
	_output_only_file = new char[ strlen( file ) + 1 ];
	strcpy(_output_only_file, file);
}
const char* FileStreamManager::getOutputFile()
{
	if(_output_only_file){
		return _output_only_file;
	}
	return getFile();
}

void FileStreamManager::setInitialRec(longint_t rec)
{
	_initial_rec = rec;
}
longint_t FileStreamManager::getInitialRec()
{
	return _initial_rec;
}
void FileStreamManager::setInitialRecLast(bool v)
{
	_initial_rec_last = v;
}
bool FileStreamManager::isInitialRecLast()
{
	return _initial_rec_last;
}
void FileStreamManager::setDrawObjectPriority(bool v)
{
	_object_priority = v;
}
bool FileStreamManager::getDrawObjectPriority()
{
	return _object_priority;
}
/*
void FileStreamManager::setIsUserDirectory(bool user)
{
	_is_user_directory = user;
}
void FileStreamManager::setIsUserRecord(bool user)
{
	_is_user_record_name = user;
}
void FileStreamManager::setIsUserObjectFile(bool user)
{
	_is_user_object_file = user;
}
bool FileStreamManager::isUserDirectory()
{
	return _is_user_directory;
}
bool FileStreamManager::isUserRecord()
{
	return _is_user_record_name;
}
bool FileStreamManager::isUserObjectFile()
{
	return _is_user_object_file;
}
*/
void FileStreamManager::setDivideDirectory(const string& directory)
{
	if (_record_directory) {
		delete[] _record_directory;
		_record_directory = 0;
	}
	if (directory.length() > 0){
		if (directory[0]) {
			string pathpart;
			string directory_path(directory);
			string relative_path;
			if (futl_pathpart(_file.path.c_str(), pathpart)) {
				futl_relative_path(directory_path, pathpart, relative_path);
			}
			if (relative_path.length() > 0) {
				/* Set relative path */
				_record_directory = new char[relative_path.length() + 1];
				strcpy(_record_directory, relative_path.c_str());
			}
			else {
				_record_directory = new char[directory.length() + 1];
				strcpy(_record_directory, directory.c_str());
			}
		}
	}
}
void FileStreamManager::getDivideDirectory(string& directory, bool raw)
{
	directory.clear();
	if (_record_directory) {
		directory = _record_directory;
		if (!raw) {
			if (futl_is_abspath(directory)) {
				return;
			}
			string base_path;
			string absolute_path;
			if (futl_pathpart(_file.path.c_str(), base_path)) {
				futl_absolute_path(directory, base_path, absolute_path);
				directory = absolute_path;
				return;
			}
		}
	}
}
//const char* FileStreamManager::getHeaderDirectory()
//{
//	return _record_directory;
//}

void FileStreamManager::setObjectDirectory(const char* directory)
{
	if (_object_directory) {
		delete[] _object_directory;
		_object_directory = 0;
	}
	if (directory && directory[0]) {
		_object_directory = new char[strlen(directory) + 1];
		strcpy(_object_directory, directory);
	}
}
const char* FileStreamManager::getObjectDirectory()
{
	return _object_directory;
}

void FileStreamManager::setRecordFileName(const char* file_name)
{
	if (_record_file_name) {
		delete[] _record_file_name;
		_record_file_name = NULL;
	}
	if (file_name && file_name[0]) {
		_record_file_name = new char[strlen(file_name) + 1];
		strcpy(_record_file_name, file_name);
	}
}
const char* FileStreamManager::getRecordFileName()
{
	return _record_file_name;
}
//const char* FileStreamManager::getHeaderRecord()
//{
//	//if(_is_user_record_name){
//	return _record_file_name;
//}

void FileStreamManager::setDrawObjectFile(const char* file_name)
{
	if (_draw_object_file) {
		delete[] _draw_object_file;
		_draw_object_file = NULL;
	}
	if (file_name && file_name[0]) {
		_draw_object_file = new char[strlen(file_name) + 1];
		strcpy(_draw_object_file, file_name);
	}
}
const char* FileStreamManager::getDrawObjectFile()
{
	return _draw_object_file;
}
//const char* FileStreamManager::getHeaderObjectFile()
//{
//	//if (_is_user_object_file) {
//	return _draw_object_file;
//}

void FileStreamManager::getUserBinaryUdfData(UserBinaryUdfData& user_data)
{
	string text;
	user_data.setInitialRec(getInitialRec());
	user_data.setInitialRecLast(isInitialRecLast());
	user_data.setDrawObjectPriority(getDrawObjectPriority());
	getDivideDirectory(text, true);
	user_data.setUserHeaderDirectory(text.c_str());
	user_data.setUserHeaderObjectDirectory(getObjectDirectory());
	user_data.setUserHeaderRecord(getRecordFileName());
	user_data.setUserHeaderObjectFile(getDrawObjectFile());
}
void FileStreamManager::setUserBinaryUdfData(UserBinaryUdfData* user_data)
{
	if (!user_data) {
		return;
	}
	this->setInitialRec(user_data->getInitialRec());
	this->setInitialRecLast(user_data->isInitialRecLast());
	this->setDrawObjectPriority(user_data->getDrawObjectPriority());
	setDivideDirectory(user_data->getUserHeaderDirectory().c_str());
	setObjectDirectory(user_data->getUserHeaderObjectDirectory().c_str());
	setRecordFileName(user_data->getUserHeaderRecord().c_str());
	setDrawObjectFile(user_data->getUserHeaderObjectFile().c_str());
}

// Include files.
void FileStreamManager::clearIncludeFile()
{
	_file.includes.clear();
}
unsigned int FileStreamManager::sizeIncludeFile()
{
	return _file.includes.size();
}
int FileStreamManager::setIncludeFile( const char* inc_file )
{
	if(!inc_file) return -1;
	if(!inc_file[0]) return -1;
	_file.includes.push_back(inc_file);
	return _file.includes.size();
}
const char* FileStreamManager::getLastIncludeFile()
{
	if(sizeIncludeFile() <= 0){
		return NULL;
	}
	return _file.includes.back().c_str();
}
int FileStreamManager::getIncludeFiles( vector<string>& inc_files )
{
	inc_files = _file.includes;
	return inc_files.size();
}

// Temporary files.
void FileStreamManager::releaseTemporary()
{
	_temporary_file = false;
	_temporary_file_name = "";
}

int FileStreamManager::deleteTemporary()
{
	int ret = 0;
	if(_temporary_file){
		ret = fcache_file_delete(_temporary_file_name.c_str());
		releaseTemporary();
	}
	return ret;
}

string& FileStreamManager::SaveFileName()
{
	return _save_file_name_when_temporary;
}

int
FileStreamManager::openFile( const char* path, FileStreamShelterMode fmode )
{
	char* file = 0x0;
	if(path){
		file = (char*)path;
		_file.path = file; // strdup(file);
		if(fmode == fssm_non) fmode = fssm_in_binary;
	}
	else{
		file = (char*)_file.path.c_str();
		fmode = fssm_in_binary;
	}
	if(!file) return 0;
	if(!file[0]) return 0;
	if( !exfile( file ) ) return 0;
	if(_fss) delete _fss;
	_fss = new FileStreamShelter();
	if( ! _fss->modeCheck( fmode ) ) return 0;
	_fss->open(file,_fss->mode(fmode));
	set_last_opened_file( file ); // openFile or openTempFile.
	return (_fss->good() > 0 ? 1 : 0);
}
int
FileStreamManager::openTempFile( const char* path, FileStreamShelterMode fmode )
{
	char* file = 0x0;
	if(path){
		file = (char*)path;
		if(fmode == fssm_non) fmode = fssm_in_binary;
	}
	else{
		file = (char*)_file.path.c_str();
		fmode = fssm_in_binary;
	}
	if(!file) return 0;
	if(!file[0]) return 0;
	if( !exfile( file ) ) return 0;
	if(_fss) delete _fss;
	_fss = new FileStreamShelter();
	if( ! _fss->modeCheck( fmode ) ) return 0;
	_fss->open(file,_fss->mode(fmode));
	set_last_opened_file( file ); // openFile or openTempFile.
	return 1;
}
const char* FileStreamManager::getOpenedFile()
{
	if (_last_opend_file.length() == 0) {
		return 0;
	}
	return _last_opend_file.c_str();
}
bool FileStreamManager::isOpenedVirtual()
{
	return _last_opened_is_virtual;
}

void* 
FileStreamManager::getStream()
{
	if(_fss){
		return _fss->getstream();
	}
	else{
		this->openFile();
		if(_fss) return _fss->getstream();
	}
	return 0x0;
}
void
FileStreamManager::closeFile()
{
	if(_fss){
		_fss->close();
		delete _fss;
	}
	_fss = 0x0;
}

int
FileStreamManager::good()
{
	if(_fss){
		return _fss->good();
	}
	return 0;
}

bool
FileStreamManager::setFileTime()
{
	char* file = (char*)_file.path.c_str();
	if(!file) return false;
	if(!file[0]) return false;
	if( !exfile( file ) ) return false;
	_file.file_time = get_time_status( file );
	return true;
}

#define CACHE_FTIME_DIFF  2
int
FileStreamManager::timeCompare( const char* path )
{
	char* file = 0x0;
	if(path){
		file = (char*)path;
	}
	else{
		file = (char*)_file.path.c_str();
	}
	if(!file) return (-1);
	if(!file[0]) return (-1);
	if( !exfile( file ) ) return (-1);
	if(this->_file.file_time <= 0) return 0;
	time_t now_ftime = get_time_status( file );
	if((_file.file_time - CACHE_FTIME_DIFF) <= now_ftime
		&& now_ftime <= (_file.file_time + CACHE_FTIME_DIFF)){
		return 0;
	}
	return 1;
}

void FileStreamManager::setRecSize( UINT rsize ){
	_file.rec_size = rsize;
}

UINT FileStreamManager::getRecSize(){
	return _file.rec_size;
}

UINT FileStreamManager::getLastRecordNumber() {
	return _file.rec_labelpos.getLastRecordNumber();
}

//
// about Locking.
//
bool
FileStreamManager::lock()
{ // USE in PLATFORM.
	char* file = (char*)_file.path.c_str();
	if(!file) return false;
	if(!file[0]) return false;
	bool rb = false;
	switch(fcache_file_access(file)){
	case 0: // EXIST THE FILE, BUT CAN NOT ACCESS.
		break;
	case 2: // READ-ONLY.
		break;
	case 4: // WRITE-ONLY.
		break;
	case 6: // READ & WRITE.
		rb = true;
		break;
	default: // NO FILE.
		break;
	}
	return rb;
}
bool
FileStreamManager::unlock()
{
	return false;
}
bool
FileStreamManager::islock()
{
	return false;
}

// Is quick output possible?
bool FileStreamManager::quickOutputAppendRecord()
{
	if(_rec_operation->isAppendOnly()){
		if(_rec_operation->sizeChangeRecord() == 1){
			return true;
		}
	}
	//-if(_vrec.getUnconditionalAllSize() == 1){
	//-	if(_vrec.getAllNum(eVIRTUAL_ACCESS_APPEND) == 1){
	//-		return true;
	//-	}
	//-}
	return false;
}

//
// Record Information.
//
// Specification to store the record information.
void FileStreamManager::useRecTemporary(int size)
{
	_file.rec_labelpos.useTemporary(size);
}
void FileStreamManager::uselessRecTemporary()
{
	_file.rec_labelpos.uselessTemporary();
}

bool
FileStreamManager::appendRecInfo(
	UINT recno,
	const char* label,
	const REC_LINENUMBER_TYPE lastLine,
	const REC_POSITION_TYPE   lastPosition,
	REC_LINENUMBER_TYPE       appendLine, // Appended file line no.
	REC_POSITION_TYPE         appendSize, // Appended file size.
	const char*               record_file
)
{
	// LINE NUMBER OF THE ORIGINAL FILE.
	REC_LINENUMBER_TYPE sumline = lastLine;   // getLineNo();
	// BYTE SIZE OF THE ORIGINAL FILE.
	REC_POSITION_TYPE sumbyte = lastPosition; // getLastPosition();
	// zR[hR[hւ̈ڍs
	bool rb = setRecInfo(recno,label,sumline,sumbyte,record_file);
	sumbyte += appendSize;
	sumline += appendLine;
	setLastPosition(sumbyte);
	setLastLineNo(sumline);
	return rb;
}

bool
FileStreamManager::setRecInfo(
		UINT recno,
		const char* label,
		UINT line,
		REC_POSITION_TYPE pos,
		const char* record_file,
		bool binary_record_file
)
{
	return _file.rec_labelpos.setRec(recno,label,line,pos,record_file, binary_record_file);
}
bool
FileStreamManager::getRecInfo(
		UINT recno,		// IN
		UINT* line,
		REC_POSITION_TYPE* pos  // OUT
)
{
	return _file.rec_labelpos.getRec(recno,*line,*pos);
}
bool
FileStreamManager::getRecInfo(
	UINT recno,				// IN
	const char** label,		// OUT ( not delete. )
	UINT* line, 			// OUT (=0)
	REC_POSITION_TYPE* pos,  // OUT (=0)
	string* record_file,	// Divided record file. (=0)
	bool* binary_record_file // (=0)
)
{
	UINT tline = 0;
	REC_POSITION_TYPE tpos = 0;
	bool rb = _file.rec_labelpos.getRec(recno,tline,tpos,label,record_file,binary_record_file);
	if(line) *line = tline;
	if(pos) *pos = tpos;
	return rb;
}
bool
FileStreamManager::getRecInfo(
	const char* label,		// IN
	UINT* recno,			// OUT
	UINT* line,				// OUT
	REC_POSITION_TYPE* pos, // OUT
	string* record_file,	// OUT Divided record file (=0)
	bool* binary_record_file	// OUT  (=0)
)
{
	if( _file.rec_labelpos.searchRec(label,*recno,*line,*pos) ){
		if(record_file){
			return _file.rec_labelpos.getRec(*recno,*line,*pos,0,record_file,binary_record_file);
		}
		return true;
	}
	// Virtual records (edited or appended records).
	CacheRecordOperation* recop = getRecordOperation();
	unsigned int record = 0;
	if(recop->findRecordFromLabel( label, record )){
		if(recno) *recno = record;
		if(line) *line = 0;
		if(pos) *pos = 0;
		if(record_file) record_file->clear();
		if(binary_record_file) *binary_record_file = false;
		return true;
	}
	return true;
	//-bool rb = false;
	//-CacheVirtualRecord* vrec = getVirtualRecord();
	//-TemporaryCacheRecord *tvrec = 0x0;
	//-if(vrec->getVRec(eVIRTUAL_ACCESS_BOTH,label,&tvrec)){
	//-	if(tvrec){
	//-		if(line) *line = 0;
	//-		if(pos) *pos = 0;
	//-		if(tvrec->available()){
	//-			*recno = tvrec->getRecordNo();
	//-			return true;
	//-		}
	//-	}
	//-}
	//-return false;
}
bool
FileStreamManager::getRecInfoExtend(
	UINT recno,			// IN
	const char** label	// OUT ( not delete. )
	//bool forceGet
)
{
	CacheRecordOperation* recop = getRecordOperation();
	bool rb = recop->isMovedRecord( recno );
	if(rb){
		*label = recop->getRecordLabel( recno );
		if(!*label){
			if(recop->isOriginal( recno )){
				unsigned int original = recop->getOriginalRecord( recno );
				rb = getRecInfo(original,label);
			}
		}
		return rb;
	}
	else{
		rb = getRecInfo(recno,label);
		return rb;
	}
}
bool
FileStreamManager::getRecLabelAll(
		vector<const char*>& label		// OUT
)
{
	return _file.rec_labelpos.getLabel(label);
}
bool
FileStreamManager::getRecLabelExtend(
	vector<const char*>& label	// OUT
)
{
	bool rb = false;
	// Labels of original records.
	vector<const char*> labelp;
	rb = _file.rec_labelpos.getLabel(labelp);
	if(rb){
		if(_rec_operation->isChanged()){
			unsigned int nrecord = _rec_operation->getRecordNumber();
			if(nrecord != labelp.size()){
				labelp.resize( nrecord ); // RESIZE ANND NO FREE MEMOEY.
			}
			unsigned int irec, jrec;
			for(irec = 0 ; irec < nrecord ; irec++ ){
				jrec = irec + 1;
				char* record_label = _rec_operation->getRecordLabel( jrec ); // RECORD : FROM 1 TO N.
				if(record_label){
					labelp[ irec ] = record_label;
				}
				else{
					if(_rec_operation->isOriginal( jrec )){
						unsigned int original = _rec_operation->getOriginalRecord( jrec );
						if(original == jrec){
							continue;
						}
						labelp[ irec ] = _file.rec_labelpos.getLabel( original );
					}
					else{
						labelp[ irec ] = NULL; // NEW INSERTED RECORD.
					}
				}
			}
		}
		label = labelp;
	}
	return rb;
		//-int idp;
		//-unsigned int i;
		//-// Labels of appended records.
		//-vector<TemporaryCacheRecord*> tmprec_array;
		//-UINT subnum = _vrec.getAllVRec(eVIRTUAL_ACCESS_APPEND,tmprec_array);
		//-UINT allnum = labelp.size() + subnum;
		//-label.resize(allnum);
		//-for(i=0;i<labelp.size();i++){
		//-	label[i] = labelp[i];
		//-}
		//-for(i=0;i<subnum;i++){
		//-	idp = tmprec_array[i]->getRecordNo() - 1;
		//-	label[idp] = tmprec_array[i]->getLabel();
		//-}
		//-// Labels of edited records.
		//-subnum = _vrec.getAllVRec(eVIRTUAL_ACCESS_EDIT,tmprec_array);
		//-for(i=0;i<subnum;i++){
		//-	idp = tmprec_array[i]->getRecordNo() - 1;
		//-	label[idp] = tmprec_array[i]->getLabel();
		//-}
}

/*
 * get_original : Get original information only.
 */
bool FileStreamManager::getBinaryRecordInfo(
	UINT recno,
	REC_POSITION_TYPE& pos,
	bool get_virtual_info
)
{
	if (get_virtual_info) {
		CacheRecordOperation* recop = getRecordOperation();
		if (recop->isEditedRecord(recno)) { // Original & edited, inserted, appended.
			pos = 0;
			return true;
		}
	}
	REC_LINENUMBER_TYPE tline = 0;
	return _file.rec_labelpos.getRec(recno, tline, pos, 0);
}

/**
 * @fn
 * Get data position list
 * @param (recNumber) record number
 * @return data position list or 0.
 */
SortedDataPositionList* FileStreamManager::getBinaryDataPosition(
	unsigned int recNumber
)
{
	return _file.rec_labelpos.getDataPosition(recNumber);
}

/**
 * @fn
 * Set data position list
 * @param (recNumber) record number
 * @param (datapos) data position list
 */
bool FileStreamManager::setBinaryDataPosition(
	unsigned int recNumber,
	SortedDataPositionList* datapos
)
{
	return _file.rec_labelpos.setDataPosition(recNumber, datapos);
}

// Divided record files.
bool FileStreamManager::compareRecFile(
	unsigned int recno,
	const char* rec_file
)
{
	const char* stored_rec_file = getRecFile(recno,NULL);
	if(stored_rec_file){
		if(rec_file){
			if(strcmp(stored_rec_file,rec_file) == 0){
				return true;
			}
		}
	}
	else{
		if(!rec_file) return true; // Both are NULL.
	}
	return false;
}
bool FileStreamManager::setRecFile(
	unsigned int recno,
	const char* rec_file,
	bool binary_record_file
)
{
	return _file.rec_labelpos.setRecFile( recno, rec_file, binary_record_file );
}
const char* FileStreamManager::getRecFile(
	unsigned int recno,
	bool* binary_record_file
)
{
	return _file.rec_labelpos.getRecFile( recno, binary_record_file );
}

bool FileStreamManager::getSaveDivideMode()
{
	switch (_convert_divided_mode) {
	case 0:
		return _save_divided_record;
	case 1: /* SINGLE */
		return false;
	case 2: /* DIVIDE */
		return true;
	}
	return _save_divided_record;
}
void FileStreamManager::setSaveDivideMode(bool divide)
{
	_save_divided_record = divide;
}

//unsigned char FileStreamManager::getConvertDivideMode()
//{
//	return _convert_divided_mode;
//}
void FileStreamManager::setConvertDivideMode(unsigned char divide)
{
	_convert_divided_mode = divide;
}

bool FileStreamManager::isDividedRecord()
{
	return _file.rec_labelpos.isDividedRecord();
}
void FileStreamManager::setDividedRecord( bool divide )
{
	setSaveDivideMode(divide);
	if(!_rec_operation) return;
	if(_rec_operation->isRecordChanged()){ // Already changed (delete/insert/append).
		return;
	}
	if(_rec_operation->isRecordEdited()){ // Already edited.
		return;
	}
	_file.rec_labelpos.setDividedRecord( divide );
}
bool FileStreamManager::existDividedRecord()
{
	return _file.rec_labelpos.existDividedRecord();
}

#if defined(USING_NONDIVIDED_RECORD)
bool FileStreamManager::existNondividedRecord()
{
	return _file.rec_labelpos.existNondividedRecord();
}
void FileStreamManager::setNondividedRecord()
{
	_file.rec_labelpos.setNondividedRecord();
}
#endif
// In saving a divided udf.
CacheDividedRecordOperation* FileStreamManager::makeDividedRecord(
	bool overwrite,
	const char* outputfile
)
{
	char* current_source_file = getFile();
	if(!current_source_file){
		return NULL;
	}
	if(!*current_source_file){
		return NULL;
	}
	//-if(existDividedRecord()){
	if(isDividedRecord() && !isBinaryMode()){
		CacheDividedRecordOperation* divope = new CacheDividedRecordOperation( _rec_operation, &_file.rec_labelpos );
		divope->setSourceOutputFile( overwrite, current_source_file, outputfile );
		//divope->setDirectory( directory.c_str() );
		divope->makeDivideRecordData();
		return divope;
	}
	return NULL;
}

//bool
//FileStreamManager::deleteRecAfter( unsigned int record )
//{
//	return _file.rec_labelpos.deleteAfter(record);
//}

bool FileStreamManager::changeRecInfo(
	unsigned int recNumber,
	bool changeLabel,
	bool changeLine,
	bool changePosition,
	const char*         label,
	REC_LINENUMBER_TYPE line,
	REC_POSITION_TYPE   position
)
{
	return _file.rec_labelpos.changeRecValue(recNumber,
				changeLabel,changeLine,changePosition,
				label,line,position);
}

bool 
FileStreamManager::editRecLabel( UINT record, const char* label )
{
	// if(record <= 0 || record > _file.rec_labelpos.getNumber()) return false;
	if(record <= 0 || record > getRecSize()) return false;
	return _file.rec_labelpos.setRec(record,(char*)label,0,0,0);
}

bool 
FileStreamManager::editRecLabelExtend( UINT record, const char* label )
{
	CacheRecordOperation* recop = getRecordOperation();
	if(recop->isChanged()){
		if(recop->setEditRecord(record,label)){
			return true;
		}
	}
	//-bool rb;
	//-CacheVirtualRecord* vrec = this->getVirtualRecord();
	//-TemporaryCacheRecord* virt_rec = 0x0;
	//-rb = vrec->getVRec(eVIRTUAL_ACCESS_EDIT,record,&virt_rec);
	//-if(rb){
	//-	virt_rec->setLabel(label);
	//-	return true;
	//-}
	//-else{
	//-	rb = vrec->getVRec(eVIRTUAL_ACCESS_APPEND,record,&virt_rec);
	//-	if(rb){
	//-		virt_rec->setLabel(label);
	//-		return true;
	//-	}
	//-}
	// if(record <= 0 || record > _file.rec_labelpos.getNumber()) return false;
	if(record <= 0 || record > getRecSize()) return false;
	return _file.rec_labelpos.setRec(record,(char*)label,0,0,0);
}

// At the end of parsing a udf-file.
void FileStreamManager::callAtEndOfFirstParse()
{
	movePosSizeToRecSize();
	createRecordOperation();
}
void
FileStreamManager::movePosSizeToRecSize()
{
	// UINT nrec = getFileRecSize();
	UINT zrec = getLastRecordNumber();
	setRecSize(zrec);
}

void
FileStreamManager::event( CACHE_EVENT_DATA& evdata )
{
	switch(evdata.status){
	case eEVENT_STATUS_IGNORE: return;
	case eEVENT_STATUS_READY:
		break;
	case eEVENT_STATUS_NORMAL:
		if(evdata.evtype == eEVENT_TYPE_CHANGE_RECORD){
			//evdata.content.record
		}
		break;
	case eEVENT_STATUS_ABNORMAL:
		break;
	}
}

// Binary Record.
void FileStreamManager::changeToBinaryMode()
{
	unsigned int lastRec = getRecSize();
	if(isBinaryRecord(lastRec)) return;
	// Still not binary mode.
	lastRec++;
	startBinary();
	setBinaryStartRecord(lastRec);
}
bool FileStreamManager::isBinaryMode()
{
//#if defined(USE_CACHE_BINARYIO)
	return _file.rec_labelpos.hasBinary();
//#else
//	return false;
//#endif
}
void FileStreamManager::startBinary()
{
	_file.rec_labelpos.startBinary();
}
void FileStreamManager::clearBinary()
{
	_file.rec_labelpos.clearBinary();
}
void FileStreamManager::setBinaryStartRecord( unsigned int startRecord )
{
	_file.rec_labelpos.setBinaryStartRecord(startRecord);
}
unsigned int FileStreamManager::getBinaryStartRecord()
{
	return _file.rec_labelpos.getBinaryStartRecord();
}
bool FileStreamManager::isBinaryRecord( unsigned int record )
{
	return _file.rec_labelpos.isBinaryRecord(record);
}
//              +------------
//              v
// begin{binary}0DATA position.
void FileStreamManager::beginBinary( REC_POSITION_TYPE binaryPosition )
{
	_file.rec_labelpos.setBeginBinaryPosition(binaryPosition);
}
REC_POSITION_TYPE FileStreamManager::beginBinaryPosition()
{
	return _file.rec_labelpos.beginBinaryPosition();
}
// Common(Initial) record position.
void FileStreamManager::setBinaryInitialRecPos( REC_POSITION_TYPE binaryPosition )
{
	_file.rec_labelpos.setBinaryInitialPosition(binaryPosition);
}
REC_POSITION_TYPE FileStreamManager::getBinaryInitialRecPos()
{
	return _file.rec_labelpos.getInitialPosition();
}

// Utility.
bool
FileStreamManager::makepath(const char* path, const char* fname, string& fullpath)
{
	return futl_makepath(path, fname, fullpath);
}
bool
FileStreamManager::splitpath(const char* path, string& pathpart, string& filepart)
{
	return futl_splitpath(path,pathpart,filepart);
}

int FileStreamManager::pathCompare(const char* path1,const char* path2)
{
	if(!path1) return -1;
	if(!path2) return -1;
	string abspath1,abspath2;
	futl_string_abspath( abspath1, path1 );
	futl_string_abspath( abspath2, path2 );
	return futl_path_compare(abspath1.c_str(),abspath2.c_str());
}

// filepath
bool FileStreamManager::makeDataNamePath( const char* post_fix, string& outpath )
{
	char* curr_file = getFile();
	return fcache_make_output_directory( curr_file, post_fix, outpath );
}

//
// Clear myself.
//
void
FileStreamManager::clear(bool reload)
{
	// File opeation data.
	clearOperation(reload);
	initOperation();
	//_fss->clear();
	//_data_loc_info->clearLocInfo(); // Reload.
	//-_vrec.clearVirtualRecord(); // in Destructor!!
	if(_rec_operation){
		_rec_operation->clearRecordOperation();
	}
	if(_fss){
		_fss->close();
		delete _fss;
	}
	_fss = 0x0;
}

